/* --- BoxOver ---
/* --- v 2.1 17th June 2006
By Oliver Bryant with help of Matthew Tagg
http://boxover.swazz.org */

// namespace
function BoxOver( ) {

var oDv=document.createElement("div");
var dvHdr=document.createElement("div");
var dvBdy=document.createElement("div");
var dvFdr=document.createElement("div");

var ELEMENT_HAS_BOX_SPEC           = 1;
var ELEMENT_DOES_NOT_HAVE_BOX_SPEC = 2;

var boxMove         = false;
var fixposx         = 0;
var fixposy         = 0;
var lockX           = 0;
var lockY           = 0;
var ox              = 10;
var oy              = 10;
var mouseX          = 0;
var mouseY          = 0;
var boEnabled       = true;
var ID              = null;
var boHideRefCount  = 0;

var elementUsingBoxOver         = null;
var elementWithMouseOver        = null;
var lastElementWithMouseOver    = null;
var currentBoxoverElement       = null;
var lastBoxoverElement          = null;

BoxOver.ResetDisplayState = function( )
{
    boxMove         = false;
    fixposx         = 0;
    fixposy         = 0;
    lockX           = 0;
    lockY           = 0;
    ox              = 10;
    oy              = 10;
    mouseX          = 0;
    mouseY          = 0;
    boEnabled       = true;
    ID              = null;
    boHideRefCount  = 0;

    elementUsingBoxOver         = null;
    elementWithMouseOver        = null;
    lastElementWithMouseOver    = null;
    currentBoxoverElement       = null;
    lastBoxoverElement          = null;
};

function init()
{
    oDv.appendChild( dvHdr );
    oDv.appendChild( dvBdy );
    oDv.appendChild( dvFdr );

    oDv.style.position="absolute";

    hideBox( );

    document.body.appendChild( oDv );
}


function checkElemBO(txt)
{
    if (!txt || typeof(txt) != 'string') return false;

    if ( (txt.indexOf('header')>-1) &&
         (txt.indexOf('body')>-1) &&
         (txt.indexOf('[')>-1)&&(txt.indexOf('[')>-1))
    {
        return true;
    }

    return false;
}

function ParseBOSpecIfNecessary( element )
{
    if ( element.boxSpec !== undefined )
    {
        return;
    }

    // Note we need to scan up DOM here, some elements like TR don't get triggered as srcElement
    for ( var curNode = element;
          curNode.parentNode && curNode.boxSpec === undefined;
          curNode = curNode.parentNode )
    {
        if ( ! checkElemBO( curNode.title ) )
        {
            curNode.boxSpec = ELEMENT_DOES_NOT_HAVE_BOX_SPEC;

            continue;
        }

        curNode.boHDR=getParam('header',curNode.title);
        curNode.boBDY=getParam('body',curNode.title);
        curNode.boFDR=getParam('footer',curNode.title);

        curNode.fixX=parseInt(getParam('fixedrelx',curNode.title));
        curNode.fixY=parseInt(getParam('fixedrely',curNode.title));

        curNode.absX=parseInt(getParam('fixedabsx',curNode.title));
        curNode.absY=parseInt(getParam('fixedabsy',curNode.title));

        curNode.offY=(getParam('offsety',curNode.title)!='')?parseInt(getParam('offsety',curNode.title)):10;
        curNode.offX=(getParam('offsetx',curNode.title)!='')?parseInt(getParam('offsetx',curNode.title)):10;

        curNode.fade=(getParam('fade',curNode.title)=='on')?true:false;
        curNode.fadespeed=(getParam('fadespeed',curNode.title)!='')?getParam('fadespeed',curNode.title):0.04;

        curNode.delay=(getParam('delay',curNode.title)!='')?parseInt(getParam('delay',curNode.title)):0;

        curNode.title='';
        curNode.boxSpec = ELEMENT_HAS_BOX_SPEC;
    }
}

function getParam(param,list)
{
    var reg = new RegExp('([^a-zA-Z]' + param + '|^' + param + ')\\s*=\\s*\\[\\s*(((\\[\\[)|(\\]\\])|([^\\]\\[]))*)\\s*\\]');

    var res = reg.exec(list);

    if ( res )
    {
        return res[2].replace('[[','[').replace(']]',']');
    }

    return '';
}

function GetLeftPosition(elem)
{
    var x=0;
    if (elem.calcLeft)
        return elem.calcLeft;
    var oElem=elem;
    while(elem){
         if ((elem.currentStyle)&& (!isNaN(parseInt(elem.currentStyle.borderLeftWidth)))&&(x!=0))
            x+=parseInt(elem.currentStyle.borderLeftWidth);
         x+=elem.offsetLeft;
         elem=elem.offsetParent;
      }
    oElem.calcLeft=x;
    return x;
}

function GetTopPosition(elem)
{
     var x=0;
     if (elem.calcTop)
        return elem.calcTop;
     var oElem=elem;
     while(elem){
         if ((elem.currentStyle)&& (!isNaN(parseInt(elem.currentStyle.borderTopWidth)))&&(x!=0))
            x+=parseInt(elem.currentStyle.borderTopWidth);
         x+=elem.offsetTop;
             elem=elem.offsetParent;
     }
     oElem.calcTop=x;
     return x;
}

function applyStyles()
{
    // remove the existing DIVs
    oDv.removeChild(dvFdr);
    oDv.removeChild(dvBdy);
    oDv.removeChild(dvHdr);

    // create the new DIVs
    dvHdr=document.createElement("div");
    dvBdy=document.createElement("div");
    dvFdr=document.createElement("div");

    // add the styles
    BoxOver.defFdrStyle( dvFdr );
    BoxOver.defBdyStyle( dvBdy );
    BoxOver.defHdrStyle( dvHdr );

    // add the content
    dvHdr.innerHTML=currentBoxoverElement.boHDR;
    dvBdy.innerHTML=currentBoxoverElement.boBDY;
    dvFdr.innerHTML=currentBoxoverElement.boFDR;

    // append the DIVs
    if ( currentBoxoverElement.boHDR != '' )
    {
        oDv.appendChild( dvHdr );
    }

    if ( currentBoxoverElement.boBDY != '' )
    {
        oDv.appendChild( dvBdy );
    }

    oDv.appendChild( dvFdr );
}

// Customised function for inner window dimension
function SHW()
{
    var width = 0;
    var height = 0;

    if (document.body && (document.body.clientWidth !=0))
    {
        width=document.body.clientWidth;
        height=document.body.clientHeight;
    }
    if (document.documentElement && (document.documentElement.clientWidth!=0) && (document.body.clientWidth + 20 >= document.documentElement.clientWidth))
    {
        width=document.documentElement.clientWidth;
        height=document.documentElement.clientHeight;
    }

    return [ width, height ];
}

function IsElementChildOfBoxOver( element )
{
    return isChild( element, dvHdr ) || isChild( element, dvBdy );
}

function OnBoxoverElementChange( newElement )
{
    lastBoxoverElement    = currentBoxoverElement;
    currentBoxoverElement = newElement;

    if ( newElement === lastBoxoverElement )
    {
        return;
    }

    applyStyles( );

    fixposx = newElement.absX;
    if ( ! isNaN( newElement.fixX ) )
    {
        fixposx = GetLeftPosition( newElement ) + newElement.fixX;
    }

    fixposy = newElement.absY;
    if ( !isNaN( newElement.fixY ) )
    {
        fixposy = GetTopPosition( newElement ) + newElement.fixY;
    }

    lockX = 0;

    lockY = 0;

    boxMove = true;

    ox = ( newElement.offX ? newElement.offX : 10 );
    oy = ( newElement.offY ? newElement.offY : 10 );

    if ( ! boEnabled )
    {
        hideBox( );
        return;
    }

    var makeVisible = null;

    if ( newElement.fade )
    {
        makeVisible = function( )
        {
            fadeIn( newElement.fadespeed );
        };
    }
    else
    {
        COL=1;

        makeVisible = function( )
        {
            showBox( );

            AdjustBOPosition( );

            ID=null;
        };
    }

    if ( ID != null )
    {
        clearTimeout( ID );
    }

    ID = setTimeout( makeVisible, newElement.delay );
}

function ClearBoxoverElement( )
{
    currentBoxoverElement = null;

    if ( ID != null )
    {
        clearTimeout( ID );
    }

    hideBox( );
}

function OnMouseMovedToElementWithoutBoxover( )
{
    // Find the box item
    if ( ! elementWithMouseOver.boxItem )
    {
        var iterElem = elementWithMouseOver;
        while ( ( iterElem.boxSpec == ELEMENT_DOES_NOT_HAVE_BOX_SPEC ) && ( iterElem.parentNode ) )
        {
            iterElem=iterElem.parentNode;
        }

        elementWithMouseOver.boxItem = iterElem;
    }

    // If the box item has a box
    if ( elementWithMouseOver.boxItem         !== undefined &&
         elementWithMouseOver.boxItem.boxSpec !== undefined &&
         elementWithMouseOver.boxItem.boxSpec === ELEMENT_HAS_BOX_SPEC )
    {
        OnBoxoverElementChange( elementWithMouseOver.boxItem );

        elementUsingBoxOver = elementWithMouseOver;
    }
    else if ( ! IsElementChildOfBoxOver( elementWithMouseOver ) && boxMove )
    {
        // The conditional here fixes flickering between tables cells.
        if ( ! isChild( currentBoxoverElement, elementWithMouseOver ) ||
             elementWithMouseOver.tagName != 'TABLE' )
        {
            ClearBoxoverElement( );
        }
    }

    lastElementWithMouseOver = elementWithMouseOver;
}

function GetEvent( e )
{
    return ( e ? e : event );
}

function GetTargetEvent( e )
{
    var evt = GetEvent( e );

    return ( evt.target? evt.target : evt.srcElement );
}

function OnDocumentMouseMove( e )
{
    elementWithMouseOver = GetTargetEvent( e );

    ParseBOSpecIfNecessary( elementWithMouseOver );

    if ( IsElementChildOfBoxOver( elementWithMouseOver ) )
    {
        if ( ! IsCurrentBoxoverElementOverElement( elementWithMouseOver ) )
        {
            ClearBoxoverElement( );
        }
    }
    // If the mouse moved onto a different element that does not have the BoxOver
    else if ( elementWithMouseOver !== lastElementWithMouseOver )
    {
        OnMouseMovedToElementWithoutBoxover( elementWithMouseOver );
    }

    if ( boxMove && currentBoxoverElement )
    {
        // This added to alleviate bug in IE6 w.r.t DOCTYPE
        var bodyScrollTop=document.documentElement&&document.documentElement.scrollTop?document.documentElement.scrollTop:document.body.scrollTop;
        var bodyScrollLeft=document.documentElement&&document.documentElement.scrollLeft?document.documentElement.scrollLeft:document.body.scrollLeft;

        var evt = GetEvent( e );

        mouseX = evt.pageX?evt.pageX-bodyScrollLeft:evt.clientX-document.body.clientLeft;
        mouseY = evt.pageY?evt.pageY-bodyScrollTop:evt.clientY-document.body.clientTop;

        AdjustBOPosition( bodyScrollTop, bodyScrollLeft );
    }
}

function AdjustBOPosition( bodyScrollTop, bodyScrollLeft )
{
    if ( currentBoxoverElement )
    {
        var availableWidth  = SHW()[0];
        var availableHeight = SHW()[1];

        mouseY < -oy ? lockY = -mouseY - oy: lockY = 0;
        mouseX < -ox ? lockX = -mouseX - ox: lockX = 0;

        if ( mouseY > ( availableHeight - oDv.offsetHeight - oy ) )
        {
            lockY = -mouseY + availableHeight - oDv.offsetHeight - oy;
        }
        if ( mouseX > ( availableWidth - dvBdy.offsetWidth - ox ) )
        {
            lockX = -mouseX - ox + availableWidth - dvBdy.offsetWidth;
        }
    }

    if ( bodyScrollTop === undefined || bodyScrollLeft === undefined )
    {
        bodyScrollTop=document.documentElement&&document.documentElement.scrollTop?document.documentElement.scrollTop:document.body.scrollTop;
        bodyScrollLeft=document.documentElement&&document.documentElement.scrollLeft?document.documentElement.scrollLeft:document.body.scrollLeft;
    }

    oDv.style.left=((fixposx)||(fixposx==0))?fixposx:bodyScrollLeft+mouseX+ox+lockX+"px";
    oDv.style.top=((fixposy)||(fixposy==0))?fixposy:bodyScrollTop+mouseY+oy+lockY+"px";
}


function OnDocumentMouseOut( e )
{
    elementUsingBoxOver = null;

    ClearBoxoverElement( );
}

function hideBox( )
{
    oDv.style.visibility='hidden';
    oDv.style.display='none';
}

function showBox( )
{
    oDv.style.visibility='visible';
    oDv.style.display='block';
}

function IsCurrentBoxoverElementOverElement( mouseOverElement )
{
    if ( currentBoxoverElement === null )
    {
        return false;
    }

    var totalScrollLeft = 0;
    var totalScrollTop  = 0;

    for ( var iterElem = mouseOverElement; iterElem; iterElem = iterElem.parentNode )
    {
        if ( ! isNaN( parseInt( iterElem.scrollTop ) ) )
        {
            totalScrollTop += parseInt( iterElem.scrollTop );
        }

        if ( ! isNaN( parseInt( iterElem.scrollLeft ) ) )
        {
            totalScrollLeft += parseInt( iterElem.scrollLeft );
        }
    }

    var boxLeft   = GetLeftPosition( currentBoxoverElement ) - totalScrollLeft;
    var boxRight  = parseInt( GetLeftPosition( currentBoxoverElement ) + currentBoxoverElement.offsetWidth ) - totalScrollLeft;
    var boxTop    = GetTopPosition( currentBoxoverElement ) - totalScrollTop;
    var boxBottom = parseInt( GetTopPosition( currentBoxoverElement ) + currentBoxoverElement.offsetHeight ) - totalScrollTop;

    return mouseX >= boxLeft   &&
           mouseX <= boxRight  &&
           mouseY >= boxTop    &&
           mouseY <= boxBottom;
}


BoxOver.Disable = function( )
{
    if ( boHideRefCount++ == 0 )
    {
        boEnabled = false;

        hideBox( );
    }
};

BoxOver.Enable = function( )
{
    if ( --boHideRefCount == 0 )
    {
        boEnabled = true;

        if ( elementWithMouseOver == elementUsingBoxOver )
        {
            oDv.style.display='block';

            AdjustBOPosition( );

            showBox( );
        }
        else
        {
            currentBoxoverElement = null;
        }
    }
};


var COL=0;
var stopfade=false;
function fadeIn(fs) {
        ID=null;
        COL=0;
        showBox( );
        fadeIn2(fs);
}

function fadeIn2(fs)
{
    COL=COL+fs;
    COL=(COL>1)?1:COL;
    oDv.style.filter='alpha(opacity='+parseInt(100*COL)+')';
    oDv.style.opacity=COL;

    if (COL<1)
    {
        var functor = function( )
        {
            fadeIn2( fs );
        };

        setTimeout( functor, 20 );
    }
}

function isChild( node, superNode )
{
    while ( node )
    {
        if ( node == superNode )
        {
            return true;
        }

        node = node.parentNode;
    }
    return false;
}

function checkMove(e)
{
    var cSrc = GetTargetEvent( e );

    if ((!boxMove)&&(!isChild(cSrc,oDv)))
    {
        hideBox();
        boxMove=true;
        currentBoxoverElement=null;
    }
}

if (typeof document.attachEvent!='undefined')
{
    window.attachEvent('onload',init);
    document.attachEvent('onmousemove',OnDocumentMouseMove);
    document.attachEvent('onmouseout',OnDocumentMouseOut);
    document.attachEvent('onclick',checkMove);
}
else
{
    window.addEventListener('load',init,false);
    document.addEventListener('mousemove',OnDocumentMouseMove,false);
    document.addEventListener('onmouseout',OnDocumentMouseOut,false);
    document.addEventListener('click',checkMove,false);
}

} // BoxOver namespace


BoxOver.defHdrStyle = function( obj )
{
    obj.style.fontWeight='bold';
    obj.style.width='281px';
    obj.style.height='17px';
    obj.style.paddingLeft='7px';
    obj.style.fontFamily='arial, sans-serif';
    obj.style.backgroundImage = "url('/images/mobile/mpp_rollover_top.gif')";
    obj.style.backgroundRepeat = "no-repeat";
    obj.style.fontSize='12';
    obj.style.color='#666666';
    //obj.style.filter='alpha(opacity=85)'; // IE
    //obj.style.opacity='0.85'; // FF
};

BoxOver.defBdyStyle = function( obj )
{
    obj.style.width='270px';
    obj.style.fontFamily='arial, sans-serif';
    obj.style.padding='0 7px 0 7px';
    obj.style.backgroundImage = "url('/images/mobile/mpp_rollover_middle.gif')";
    obj.style.backgroundRepeat = "repeat-y";
    obj.style.fontSize='11';
    //obj.style.filter='alpha(opacity=85)'; // IE
    //obj.style.opacity='0.85'; // FF
};

BoxOver.defFdrStyle = function( obj )
{
    obj.style.width='281px';
    obj.style.height='13px';
    obj.style.fontFamily='arial, sans-serif';
    obj.style.backgroundImage = "url('/images/mobile/mpp_rollover_bottom.gif')";
    obj.style.backgroundRepeat = "no-repeat";
    obj.style.fontSize='12';
    //obj.style.filter='alpha(opacity=85)'; // IE
    //obj.style.opacity='0.85'; // FF
};

BoxOver( );