/******************************************************************************
    CallWave VoiceMail Widget

    Copyright (C) 2006 CallWave, Inc.  All Rights Reserved.

 ******************************************************************************/

var VM_WIDGET_SOURCE     = 'VX';
var VM_WIDGET_VERSION    = "1.2";
var VM_WIDGET_OS_VERSION = '';
var VM_WIDGET_DEFAULT_SHOW_ACTIVATION = false;
var VM_WIDGET_DEFAULT_CALLLIST_MAX_CALLS = 4;

var VM_CALL_LIST_SYNCHRONIZATION_THRESHOLD = 1000;

function VM_GetPreference( key )
{
    if ( window.widget )
    {
        return widget.preferenceForKey( key );
    }

    if ( typeof __widgetArr == "undefined" )
    {
        __widgetArr = new Array( );
    }

    return __widgetArr[ key ];
}

function VM_SetPreference( key, value )
{
    if ( window.widget )
    {
        widget.setPreferenceForKey( value, key );
    }
    else
    {
        if ( typeof __widgetArr == "undefined" )
        {
            __widgetArr = new Array( );
        }

        __widgetArr[ key ] = value;
    }
}

function EX_Log( message )
{
    alert( message );
}

function OnAccountInformationChanged( name, emailAddress, phoneNumber )
{
    try
    {
        var userInformation = '';

        if ( phoneNumber )
        {
            userInformation +=
              tag('tr','',
                tag('td', {'class':'heading'}, "Cell Number") +
                tag('td', {'class':'userInformation'}, phoneNumber.replace(/^(\d{3})(\d{3})(\d{4})$/, "$1-$2-$3" ) )); // mobile phone number (10 digits)
        }

        if ( name )
        {
            userInformation +=
              tag('tr','',
                tag('td', {'class':'heading'}, "Name") +
                tag('td', {'class':'userInformation'}, name ));
        }

        if ( emailAddress )
        {
            userInformation +=
              tag('tr','',
                tag('td', {'class':'heading'}, "Email Address") +
                tag('td', {'class':'userInformation'}, emailAddress ));
        }

        if ( userInformation.length )
        {
            document.getElementById( 'WIDGET_personalInfo' ).innerHTML =
              tag('table', {width:'100%'}, userInformation );
        }
    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, 'VoiceMail.js::OnAccountInformationChanged( )' );
    }
}



/******************************************************************************
  PopulateCarrierNames

    Populates a popup menu with a list of carriers.

******************************************************************************/
function VM_PopulateCarrierNames( element, carrierList )
{
    var i = 0;
    for ( ; i < carrierList.length; ++i )
    {
        element.options[ element.options.length ] = new Option( carrierList[ i ][ 0 ], carrierList[ i ][ 1 ] );
    }

    element.options[ 0 ].selected = true;
}

function preloadImages( imageArr )
{
    __imageArray = new Array( );
    for ( var i = 0; i < imageArr.length; ++i )
    {
        var __imageArrayIndex = __imageArray.length;
        __imageArray[ __imageArrayIndex ] = new Image( );
        __imageArray[ __imageArrayIndex ].src = imageArr[ i ];
    }
}

var __callListSynchronizations = 0;
function OnCallListSynchronizeStart( )
{
    ++__callListSynchronizations;
}

function OnCallListSynchronizeComplete( )
{
    if ( __callListSynchronizations < VM_CALL_LIST_SYNCHRONIZATION_THRESHOLD )
    {
        return;
    }

    EX_Log( "Refreshing..." );

    widget.system( '/bin/sh Refresh.txt', function( ) { ; } );
}

function Setup( )
{
    VM_WIDGET_OS_VERSION = navigator.platform;

    preloadImages( [ VM_RESOURCE_SELECTED_ROW_IMAGE ,
                     VM_RESOURCE_PHONE_ICON_HOME    ,
                     VM_RESOURCE_PHONE_ICON_WORK    ,
                     VM_RESOURCE_PHONE_ICON_CELL    ,
                     VM_RESOURCE_PHONE_ICON_OTHER   ,
                     VM_RESOURCE_PHONE_ICON_HOME_W  ,
                     VM_RESOURCE_PHONE_ICON_WORK_W  ,
                     VM_RESOURCE_PHONE_ICON_CELL_W  ,
                     VM_RESOURCE_PHONE_ICON_OTHER_W ,
                     VM_RESOURCE_PLAY_IMAGE         ,
                     VM_RESOURCE_EDIT_IMAGE         ,
                     VM_RESOURCE_DELETE_IMAGE       ,
                     VM_RESOURCE_STOP_IMAGE         ] );

    var callsShowPopup = document.getElementById( 'WIDGET_callsShowPopup' );

    // get the "show activation" value -- default to true
    var showActivation = getShowActivation();
    var maxCallListCalls = getMaxCallListCalls();

    VM_widgetViewController = new VM_WidgetViewController( showActivation, maxCallListCalls );

    if ( window.widget )
    {
        VM_widgetViewController.getCallListView( ).m_callListHandler.m_onSynchronize             = OnCallListSynchronizeStart;
        VM_widgetViewController.getCallListView( ).m_callListHandler.m_onProcessResponseComplete = OnCallListSynchronizeComplete;

        widget.onshow = function( )
        {
            VM_widgetViewController.OnShow( );
        };

        widget.onhide = function( )
        {
            VM_widgetViewController.OnHide( );
        };

        var doneButton = document.getElementById( 'doneButton' );
        createGenericButton( doneButton, 'Done', OnBackPaneDoneButton, 67 );

        var versionCheckButton = document.getElementById( 'versionCheckButton' );
        createGenericButton( versionCheckButton, 'Check for updates', OnCheckForUpdates, 67 );

        var logoutButton = document.getElementById( 'logoutButton' );
        createGenericButton( logoutButton, 'Logout', OnLogout, 67 );
    }
    else
    {
        var doneButton = document.getElementById( 'doneButton' );
        doneButton.innerHTML = '<input type=button onClick="OnBackPaneDoneButton( )" value="Done" width="67"/>';

        var versionCheckButton = document.getElementById( 'versionCheckButton' );
        versionCheckButton.innerHTML = '<input type=button onClick="OnCheckForUpdates( )" value="Check for updates" width="67"/>';

        var logoutButton = document.getElementById( 'logoutButton' );
        logoutButton.innerHTML = '<input type=button onClick="OnLogout( );" value="Logout" width="67"/>';
    }

    // set the call list max length and "show activation" property
    var callsShowPopup = document.getElementById( 'WIDGET_callsShowPopup' );
    callsShowPopup.selectedIndex = maxCallListCalls - 1;

    document.getElementById( 'WIDGET_showActivation' ).checked = showActivation;

    document.getElementById( 'front' ).style.display='block';
}

function getShowActivation() {
    var showActivation = VM_GetPreference( PREF_KEY_SHOW_ACTIVATION );
    showActivation = (typeof showActivation != 'undefined') ? showActivation : VM_WIDGET_DEFAULT_SHOW_ACTIVATION; // use setting or don't show by default

    return showActivation;
}

function getMaxCallListCalls() {
    var maxCallListCalls = VM_GetPreference( PREF_KEY_MAX_CALLLIST_CALLS );
    maxCallListCalls = (typeof maxCallListCalls != 'undefined') ? maxCallListCalls : VM_WIDGET_DEFAULT_CALLLIST_MAX_CALLS;
    return maxCallListCalls;
}


function OpenURL( url )
{
    window.widget ? widget.openURL( url ) : window.open( url, '' );
}


/******************************************************************************
  ShowPreferences

    Handler for transitioning to back pane

******************************************************************************/
function ShowPreferences( )
{
    VM_CallListView_static.stopPlayerForAllCalls();

    var front = document.getElementById( "front" );
    var back = document.getElementById( "back" );

    window.widget && widget.prepareForTransition( "ToBack" );

    front.style.display = "none";
    back.style.display = "block";

    window.widget && setTimeout( 'widget.performTransition();', 0 );
}

function FlipToFront( )
{
    var front = document.getElementById( "front" );
    var back = document.getElementById( "back" );

    window.widget && widget.prepareForTransition( "ToFront" );

    back.style.display = "none";
    front.style.display = "block";
    VM_widgetViewController.getCallListView( ).refresh();

    VM_CallListView_static.ResetVtxt( );

    window.widget && setTimeout( 'widget.performTransition();', 0 );
}

function OnBackPaneDoneButton( )
{
    // save all the preferences
    var callsShowPopup = document.getElementById( 'WIDGET_callsShowPopup' );

    VM_widgetViewController.UpdatePreferences( callsShowPopup.options[ callsShowPopup.selectedIndex ].value,
                                               document.getElementById( 'WIDGET_showActivation' ).checked );

    FlipToFront( );
}

function OnLogout( )
{
    FlipToFront( );

    // clear out the status message... always!!!
    $('#WIDGET_alertMessageTextArea' ).html("");

    // reset the preferences
    // get the "show activation" value -- default to true
    var showActivation = getShowActivation();
    var maxCallListCalls = getMaxCallListCalls();

    var callsShowPopup = document.getElementById( 'WIDGET_callsShowPopup' );
    callsShowPopup.selectedIndex = maxCallListCalls - 1;

    document.getElementById( 'WIDGET_showActivation' ).checked = showActivation;

    VM_widgetViewController.Logout( );
}

function OnCheckForUpdates( )
{
    OpenURL('http://www.callwave.com/v2w/checkForUpdates.html' +  VM_getDefaultUrlQueryParameters());
    return false;
}

function VM_getDefaultUrlQueryParameters( )
{
    var urlQueryParameters =
        "?src=" + VM_WIDGET_SOURCE   +
        "&ver=" + VM_WIDGET_VERSION;

    var uString = VM_GetPreference( PREF_KEY_U_STRING );

    if ( uString != null && uString.length != 0 )
    {
        urlQueryParameters += "&u=" + uString;
    }

    urlQueryParameters += '&os=' + VM_WIDGET_OS_VERSION;

    return urlQueryParameters;
}

